#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 10 06:42:30 2018

@author: andyyoungs
"""


import numpy as np
import holoviews as hv
hv.extension('bokeh')

#%%opts Box (color='black', line_width=3) Image [tools=['box_select', 'lasso_select']]

xvals = np.linspace(0,4,202)
ys,xs = np.meshgrid(xvals, -xvals[::-1])
extents = (0, 0, 10, 10)
img = hv.Image(np.sin(((ys)**3)*xs))


def createBounds(xbnd):
    print ('bounds=',bounds_sel.contents['boundsx'])
    xbnd = (-0.5,-0.4) if xbnd is None else np.clip(xbnd,-0.5,0.5)
    return hv.Bounds((xbnd[0],-0.5,xbnd[1],0.5))

bounds_sel = hv.streams.BoundsX(source=img)
selection_dmap = hv.DynamicMap(createBounds, streams=[bounds_sel.rename(boundsx='xbnd')])
layout = img  * selection_dmap
layout
renderer = hv.renderer('bokeh')
doc = renderer.server_doc(layout)
doc.title = 'HoloViews App'